<?php
/*
// isdf - inventory system webstatus
// Author: Carsten Schoene
//
// $LastChangedDate: 2012-07-20 21:09:25 +0200 (Fri, 20 Jul 2012) $
// $Rev: 1619 $
*/

// define our name
define('MYNAME', "isdf");
// open syslog connection
openlog(MYNAME,LOG_PID | LOG_ODELAY,LOG_MAIL);

// check for required extensions
if ( ! extension_loaded("mysql") ) {
        if ( ! dl("mysql") ) {
                syslog(LOG_ERR,"mysql extension not loaded!");
                exit;
        }
}

// load additional files
define('BASE',dirname(__FILE__));
require_once("MDB2.php");
require_once(BASE . "/config.inc.php");
require_once(BASE . "/config-custom.inc.php");
require_once(BASE . "/db.inc.php");

echo '<html><head>
<title>inventory system - status web</title>
</head>
<body>
<form action="' . $_SERVER['PHP_SELF'] . '">
Select server UUID:
<select name="systemid" onChange="javascript:document.systemid.submit()">
';
// create database connection
$dbh =& MDB2::singleton($config['isdf']['db'], $config['mdb2']['options'] );

$uuidsql = "SELECT id,system_uuid FROM inv_system";
$res = $dbh->query($uuidsql);
if (PEAR::isError($res)) {
	syslog(LOG_ERR, "MDB2: " . $res->getMessage());
} else {
	while (( $row = $res->fetchRow(MDB2_FETCHMODE_ASSOC) )) {
		if ( isset($_GET['systemid'])) {
			if ( $row['id'] == $_GET['systemid'] ) {
				echo '<option selected value="' . $row['id'] . '">' . $row['system_uuid'] . '</option>';
			} else {
				echo '<option value="' . $row['id'] . '">' . $row['system_uuid'] . '</option>';
			}
		} else {
			echo '<option value="' . $row['id'] . '">' . $row['system_uuid'] . '</option>';
		}
	}
}
echo '
</select><input type="submit" value="Select"></form>
';

if ( isset($_GET['systemid']) ) {
		$systemid = $_GET['systemid'];
		$datasql = "SELECT datakey, value FROM inv_system_properties WHERE inv_system_id = '$systemid'";

		$datares = $dbh->query($datasql);
		if (PEAR::isError($datares)) {
			syslog(LOG_ERR, "MDB2: " . $datares->getMessage());
		} else {
			echo '<table>';
			echo '<tr><th>Key:</th><th>Value:</th></tr>';
			while (( $row = $datares->fetchRow(MDB2_FETCHMODE_ASSOC) )) {
				echo '<tr><td valign="top">' . $row['datakey'] . '</td><td>' . $row['value'] . '</td></tr>';
			}
			echo '</table>';
		}
	
}
echo '</body></html>';
$dbh->disconnect();
?>
