<?php

$config["isdf"]["custom_postvars"] = array();

$config["isdf"]["dhcp"]["system"]["net4"] = "10.10.20.0/22";
$config["isdf"]["dhcp"]["systemmgmt"]["net4"] = "10.10.24.0/22";
$config["isdf"]["dhcp"]["systempxe"]["net4"] = "10.10.28.0/22";
$config["isdf"]["dhcp"]["system"]["firstusable"] = "10.10.20.11";
$config["isdf"]["dhcp"]["systemmgmt"]["firstusable"] = "10.10.24.11";
$config["isdf"]["dhcp"]["systempxe"]["firstusable"] = "10.10.28.11";

$config["isdf"]["dhcp"]["system"]["net6"] = "";
$config["isdf"]["dhcp"]["systemmgmt"]["net6"] = "";
$config["isdf"]["dhcp"]["systempxe"]["net6"] = "";

$config["isdf"]["dhcp"]["system"]["hostnameprefix"] = "sys-";
$config["isdf"]["dhcp"]["systemmgmt"]["hostnameprefix"] = "mgmt-";
$config["isdf"]["dhcp"]["systempxe"]["hostnameprefix"] = "pxe-";

$config["isdf"]["dhcp"]["system"]["net4file"] = "/etc/dhcp3/conf.d/system4.hosts";
$config["isdf"]["dhcp"]["systemmgmt"]["net4file"] = "/etc/dhcp3/conf.d/systemmgmt4.hosts";
$config["isdf"]["dhcp"]["systempxe"]["net4file"] = "/etc/dhcp3/conf.d/systempxe4.hosts";

$config["isdf"]["dhcp"]["system"]["net6file"] = "/etc/dhcp3/conf.d/system6.hosts";
$config["isdf"]["dhcp"]["systemmgmt"]["net6file"] = "/etc/dhcp3/conf.d/systemmgmt6.hosts";
$config["isdf"]["dhcp"]["systempxe"]["net6file"] = "/etc/dhcp3/conf.d/systempxe6.hosts";

$config["isdf"]["dhcp"]["db_datakey"] = "get_system_type";
$config["isdf"]["dhcp"]["db_datavalue"] = "baremetal";

$config["isdf"]["dhcp"]["guacamole"]["createconfig"] = true;
$config["isdf"]["dhcp"]["guacamole"]["user-mapping"] = "/etc/guacamole/user-mapping.xml";
$config["isdf"]["dhcp"]["guacamole"]["defvncpw"] = "guacamoleVNC";
$config["isdf"]["dhcp"]["guacamole"]["maxvncport"] = 5901;

?>
